Subject: Re: iscsi : MaximumBurstSize & FirstBurstSize values.

From: Santosh Rao <[email-masked]>
Date: Fri, 21 Sep 2001 14:20:01 -0700

Robert Snively wrote:

> I am sorry, but I don't think this is a necessary or appropriate

> limitation.  FirstBurstSize is a PDU size, and its characteristics
> are determined by the unsolicited data buffer capability of the
> target.  MaximumBurstSize is a PDU size, and its characteristics
> are determined by the solicited data buffer size and the buffer
> size increments available to the initiator.  These may meet that
> rule, but they may also not meet that rule.  That is why there
> are two values.
>
> It may be important to clarify that FirstBurstSize overrides
> MaximumBurstSize for the first burst.

Bob,

Your solution works fine for me.

The current draft wording is not clear on how the initiator must send
un-solicited data when MaximumBurstSize is < FirstBurstSize, since the
meaning of the "F" bit in the data-out sequence is currently over-loaded to
imply end-of-sequence as well as end-of-unsolicited data. Sequence length
could be construed as less than length of un-solicited data.

Regards,
Santosh

> > -----Original Message-----
> > From: Santosh Rao [mailto:[email-masked]]
> > Sent: Friday, September 21, 2001 11:43 AM
> > To: IPS Reflector
> > Subject: iscsi : MaximumBurstSize & FirstBurstSize values.
> >
> >
> > All,
> >
> > I believe the FirstBurstSize setting has to be <= MaximumBurstSize ? I
> > suggest that this be explicitly called out in the definition of
> > FirstBurstSize.
> >
> > If this rule is not followed, an initiator would need to break the
> > un-solicited data it sends into more than 1 data-out sequence, and in
> > setting the F bit to indicate end-of-sequence, it can confuse
> > the target
> > into thinking its end of un-solicited data.
> >
> >
> > The definitions currently read :
> >
> > "4.1.1 MaximumBurstSize Field (16 bit)
> >
> > This field defines the maximum SCSI data payload in an iSCSI
> > sequence (a
> > sequence of Data-In or Data-Out PDUs ending with a Data-In or Data-Out
> > PDU with the F bit set to one) in units of 512 bytes. The      default
> > value assumed for a new iSCSI session (I_T nexus) is 512 units.
> >
> > 4.1.3 FirstBurstSize Field (16 bit)
> >
> > This field defines the maximum amount of unsolicited data an iSCSI
> > initiator may to send to the target in units of 512 bytes. The default
> > value assumed for a new iSCSI session (I_T nexus) is 128 units. "
> >
> > Regards,
> > Santosh
> >

---

From: "Sanjeev Bhagat \(TRIPACE/Zoetermeer\)" <[email-masked]>
Date: Mon, 24 Sep 2001 01:27:06 +0200

----- Original Message -----
From: "Santosh Rao" <[email-masked]>
To: "IPS Reflector" <[email-masked]>
Sent: Friday, September 21, 2001 11:20 PM
Subject: Re: iscsi : MaximumBurstSize & FirstBurstSize values.

> > MaximumBurstSize for the first burst.

Although I agree with Bob here but isnt it worth thinking, why should the
firstburstsize be greater than MaximumBurstSize. I think in all practical
implemetation firstburstsize will be lesser than MaximumBurstSize.

Considering bob's explanation, It will not be a good idea to put any
restrictions with respect to size but  just to avoid some confusion it might
be better to rename FirstBurstSize as UnsolicitedBurstSize and
MaximumBurstSize as MaximumSolicitedBurstSize.